#include <stdio.h>
#include <algorithm>
#include <math.h>
#define sqr(x) ((x)*(x))
using namespace std;
const int MaxN = 100000;
const int MaxK = 1000;
int sq[MaxN], d[MaxN+1];
int i, j, k, l, n, m, p;
FILE *fi, *fo;

int GetMin(int a, int b){
  if(!a) return b;
  return min(a, b);
}

int main(){
  memset(d, 0, sizeof(d));
  i = 0; d[0] = 1;
  do{
    sq[++i] = sqr(i);
    d[sq[i]] = 1;
  }while(sq[i] <= MaxN);
  m = i;
  fi = fopen("input.txt", "r");
  fo = fopen("output.txt", "w");
  fscanf(fi, "%i%i", &n, &k);
  for(i = 0; i <= n; i++){
    for(j = 0; j <= m; j++){
      if(i+sq[j] > MaxN) continue;
      d[i+sq[j]] = GetMin(d[i+sq[j]], d[i]+1);
    }
  }
  d[0] = 0;
  if(d[n] > k){
    fprintf(fo, "NO\n");
  }else{
    fprintf(fo, "YES\n");
    p = n;
    for(i = 1; i <= d[p]; i++){
      for(j = 1; j <= m; j++)
        if(d[n - sq[j]] == d[n] - 1){
          fprintf(fo, "%i ", j);
          n -= sq[j];
          break;
        }
    }
    #if 0
    /* It's no longer needed: statement changed.
     * Igor V. Burago
     */
    for(i = 1; i <= k-d[p]; i++){
      fprintf(fo, "0 ");
    }
    #endif
  }
  fclose(fi);
  fclose(fo);
  return 0;
}